﻿if object_id(N'T12', 'U') is not null drop table [T12]
go

if object_id(N'T11', 'U') is not null drop table [T11]
go

if object_id(N'T10', 'U') is not null drop table [T10]
go

if object_id(N'T09', 'U') is not null drop table [T09]
go

if object_id(N'T08', 'U') is not null drop table [T08]
go

if object_id(N'T07', 'U') is not null drop table [T07]
go

if object_id(N'T06', 'U') is not null drop table [T06]
go

if object_id(N'T05', 'U') is not null drop table [T05]
go

if object_id(N'T04', 'U') is not null drop table [T04]
go

if object_id(N'T03', 'U') is not null drop table [T03]
go

if object_id(N'T02', 'U') is not null drop table [T02]
go

if object_id(N'T01', 'U') is not null drop table [T01]
go

if object_id(N'IdentityNumberer', 'U') is not null drop table [IdentityNumberer]
go

if object_id(N'Trace', 'U') is not null drop table [Trace]
go

create table [Trace]
(
	[DateTime] datetime,
	[Timestamp] bigint,
	[MachineName] nvarchar(64),
	[ProcessId] int,
	[ThreadId] nvarchar(64),
	[Type] nvarchar(64) not null,
	[Message] nvarchar(1024) not null
	
	/* 主キーはありません。 */
)
go

create table [IdentityNumberer]
(
	[TableName] nvarchar(64) not null,
	[MaxIdentity] bigint not null,
	
	constraint [RXIdentityNumberer_PK] primary key ([TableName])
)
go

create table [T01]
(
	[Identity] bigint not null,
	[T01Identity] bigint,
	[Value] nvarchar(64) not null,
	
	constraint [T01_PK] primary key ([Identity]),
	constraint [T01_T01_FK] foreign key ([T01Identity]) references [T01]([Identity])
)
go

create table [T02]
(
	[Identity] bigint not null,
	[T01Identity] bigint not null,
	[Value] nvarchar(64) not null,
	
	constraint [T02_PK] primary key ([Identity]),
	constraint [T02_T01_FK] foreign key ([T01Identity]) references [T01]([Identity])
)
go

create table [T03]
(
	[Identity] bigint not null,
	[Value] nvarchar(64) not null,

	constraint [T03_PK] primary key ([Identity])
)
go

create table [T04]
(
	[Identity] bigint not null,
	[T02Identity] bigint not null,
	[T03Identity] bigint not null,
	[Value] nvarchar(64) not null,
	
	constraint [T04_PK] primary key ([Identity]),
	constraint [T04_T02_FK] foreign key ([T02Identity]) references [T02]([Identity]),
	constraint [T04_T03_FK] foreign key ([T03Identity]) references [T03]([Identity])
)
go

create table [T05]
(
	[Identity] bigint not null,
	[T03Identity] bigint not null,
	[Value] nvarchar(64) not null,
	
	constraint [T05_PK] primary key ([Identity]),
	constraint [T05_T03_FK] foreign key ([T03Identity]) references [T03]([Identity])
)
go

create table [T06]
(
	[Identity] bigint not null,
	[Value] nvarchar(64) not null,

	constraint [T06_PK] primary key ([Identity])
)
go

create table [T07]
(
	[Identity] bigint not null,
	[T04Identity] bigint not null,
	[Value] nvarchar(64) not null,
	
	constraint [T07_PK] primary key ([Identity]),
	constraint [T07_T04_FK] foreign key ([T04Identity]) references [T04]([Identity])
)
go

create table [T08]
(
	[Identity] bigint not null,
	[T04Identity] bigint not null,
	[T06Identity] bigint not null,
	[Value] nvarchar(64) not null,
	
	constraint [T08_PK] primary key ([Identity]),
	constraint [T08_T04_FK] foreign key ([T04Identity]) references [T04]([Identity]),
	constraint [T08_T06_FK] foreign key ([T06Identity]) references [T06]([Identity])
)
go

create table [T09]
(
	[Identity] bigint not null,
	[T06Identity] bigint not null,
	[Value] nvarchar(64) not null,
	
	constraint [T09_PK] primary key ([Identity]),
	constraint [T09_T06_FK] foreign key ([T06Identity]) references [T06]([Identity])
)
go

create table [T10]
(
	[Identity] bigint not null,
	[T07Identity] bigint not null,
	[T10Identity] bigint,
	[Value] nvarchar(64) not null,
	
	constraint [T10_PK] primary key ([Identity]),
	constraint [T10_T07_FK] foreign key ([T07Identity]) references [T07]([Identity]),
	constraint [T10_T10_FK] foreign key ([T10Identity]) references [T10]([Identity])
)
go

create table [T11]
(
	[PK] bigint not null,
	[Value] nvarchar(64) not null,
	
	constraint [T11_PK] primary key ([PK])
)
go

create table [T12]
(
	[PK1] bigint not null,
	[PK2] bigint not null,
	[T11PK] bigint not null,
	[Value] nvarchar(64) not null,
	
	constraint [T12_PK] primary key ([PK1], [PK2]),
	constraint [T12_T11_FK] foreign key ([T11PK]) references [T11]([PK])
)
go
