﻿using System;
using System.Data;
using System.Windows.Forms;
using TailIsland.RX;

namespace TailIsland.PetShop.CatalogMaintainer
{
    public partial class ItemForm : Form
    {
        public ItemForm()
        {
            InitializeComponent();
        }

        private void ItemForm_Load(object sender, EventArgs e)
        {
            RXForForm.ExecuteEventHandler(
                delegate
                {
                    RXForForm.SetControlMaxLengths(this, retailDataSet._Item);
                });
        }

        private void ItemForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            RXForForm.ExecuteEventHandler(
                delegate
                {
                    try
                    {
                        if (DialogResult != DialogResult.OK)
                        {
                            return;
                        }

                        itemBindingSource.EndEdit();
                        if (retailDataSet.GetChanges() == null)
                        {
                            return;
                        }

                        RXForForm.CallValidators(retailDataSet._Item);
                        if (retailDataSet.HasErrors)
                        {
                            MessageBox.Show(this, RXForForm.CollectDataSetErrors(retailDataSet), Application.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
                            e.Cancel = true;
                            return;
                        }
                    }
                    catch (Exception)
                    {
                        e.Cancel = true;

                        throw;
                    }
                });
        }
    }
}