﻿using System;
using System.Text;
using System.Web;
using System.Web.Services;
using System.ComponentModel;

namespace TailIsland.PetShop.Emulator
{
    [WebService(Namespace = "http://tailisland.com/PetShop/Emulator/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [ToolboxItem(false)]
    public class CreditCardAuthorizer : WebService
    {
        private const string chargeNumberChars = "abcdefghijkmnopqrstuvwxyzABCDEFGHJKLMNPQRSTUVWXYZ23456789";
        
        private static Random random = new Random();

        [WebMethod]
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA1801")]
        public string AuthorizeCreditCard(string company, string number, int expireMonth, int expireYear, decimal price)
        {
            //  ダミーなので、クレジット・カードの検証やロギングはやりません。

            //  検証用に、番号が「0」一文字の場合には承認しないことにします。
            if (number == "0")
            {
                return string.Empty;
            }

            return CreateChargeNumber();
        }

        private static string CreateChargeNumber()
        {
            StringBuilder sb = new StringBuilder();

            for (int i = 0; i < 20; ++i)
            {
                sb.Append(SelectCharRandomly("abcdefghijkmnopqrstuvwxyzABCDEFGHJKLMNPQRSTUVWXYZ23456789"));
            }

            return sb.ToString();
        }

        private static char SelectCharRandomly(string chars)
        {
            lock (random)
            {
                return chars[random.Next(chars.Length)];
            }
        }
    }
}
