﻿using System;
using TailIsland.RX;

namespace TailIsland.PetShop.Retail.Test
{
    /// <summary>
    ///    TailIsland.PetShop.Retailに対するユニット・テスト用の、データベース保守のためのクラスです。
    /// </summary>
    internal static class DataBaseMaintainer
    {
        /// <summary>
        ///    データベース環境を初期化します。
        /// </summary>
        internal static void Initialize()
        {
            //  テーブルを作成します。
            RXForUnitTest.ExecuteCreateSqlScript("PetShop", "ASP.NET");
            RXForUnitTest.ExecuteCreateSqlScript("PetShop", "TailIsland.RX");
            RXForUnitTest.ExecuteCreateSqlScript("PetShop", "TailIsland.PetShop.Retail");

            //  ダミー・データを投入します。
            RXForUnitTest.ExecuteChangeSqlScript("PetShop", "ASP.NET");
            RXForUnitTest.ExecuteChangeSqlScript("PetShop", "TailIsland.RX");
            RXForUnitTest.ExecuteChangeSqlScript("PetShop", "TailIsland.PetShop.Retail");
        }

        /// <summary>
        ///    データベース環境をクリーンアップします。
        /// </summary>
        internal static void Cleanup()
        {
            //  不要なテーブルを削除します。
            RXForUnitTest.ExecuteCreateSqlScript("PetShop", "TailIsland.RX-drop");
        }
    }
}
