﻿using System;
using TailIsland.RX;

namespace TailIsland.PetShop.Retail
{
    /// <summary>
    ///    カテゴリーに関する入力値検証を担当するクラスです。
    /// </summary>
    internal static class CategoryValidator
    {
        /// <summary>
        ///    入力値を検証します。
        /// </summary>
        /// <param name="dataTable">入力値が入った型付DataTable。</param>
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Performance", "CA1811")]
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA1801")]
        internal static void Validate(RetailDataSet.CategoryDataTable dataTable)
        {
            //  すべての追加/変更された行に対して……
            foreach (RetailDataSet.CategoryRow dr in RXForValidator.GetAddedOrModifiedRows(dataTable))
            {
                //  必須チェック。
                RXForValidator.AddColumnErrorIfRequireIsNot(dr, dataTable.NameColumn);
                RXForValidator.AddColumnErrorIfRequireIsNot(dr, dataTable.DescriptionColumn);
            }
        }
    }
}
