﻿using System;
using TailIsland.RX;

namespace TailIsland.PetShop.Retail
{
    /// <summary>
    ///    品目に対する入力値検証を担当するクラスです。
    /// </summary>
    internal static class ItemValidator
    {
        /// <summary>
        ///    入力値を検証します。
        /// </summary>
        /// <param name="dataTable">入力値が入った型付DataTable。</param>
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Performance", "CA1811")]
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA1801")]
        internal static void Validate(RetailDataSet.ItemDataTable dataTable)
        {
            //  念のため、クライアントのエラー・チェックを呼び出します。
            using (TailIsland.PetShop.RetailServiceAgent.RetailDataSet ds = new TailIsland.PetShop.RetailServiceAgent.RetailDataSet())
            {
                ds.Merge(dataTable.DataSet);

                TailIsland.PetShop.RetailServiceAgent.ItemValidator.Validate(ds._Item);

                dataTable.DataSet.Merge(ds);
            }

            //  今回はサーバ・サイドでのエラー・チェックはありません。
        }
    }
}
