﻿using System;
using TailIsland.RX;

namespace TailIsland.PetShop.Retail
{
    /// <summary>
    ///    写真に対する入力値検証を担当するクラスです。
    /// </summary>
    internal static class PhotographValidator
    {
        /// <summary>
        ///    入力値を検証します。
        /// </summary>
        /// <param name="dataTable">入力値が入った型付DataTable。</param>
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Performance", "CA1811")]
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA1801")]
        internal static void Validate(RetailDataSet.PhotographDataTable dataTable)
        {
            //  すべての追加/変更された行に対して……
            foreach (RetailDataSet.PhotographRow dr in RXForValidator.GetAddedOrModifiedRows(dataTable))
            {
                //  必須チェック。
                RXForValidator.AddColumnErrorIfRequireIsNot(dr, dataTable.NameColumn);

                //  写真イメージの必須チェック。
                RXForValidator.AddColumnError(dr, dataTable.PhotographImageColumn, "写真イメージは必須入力です。",
                    delegate
                    {
                        return dr.PhotographImage.Length == 0;
                    });
            }
        }
    }
}
