﻿using System;
using TailIsland.RX;

namespace TailIsland.PetShop.RetailServiceAgent
{
    public static class ItemValidator
    {
        public static void Validate(RetailDataSet._ItemDataTable dataTable)
        {
            foreach (RetailDataSet._ItemRow dr in RXForValidator.GetAddedOrModifiedRows(dataTable))
            {
                //  必須チェック。
                RXForValidator.AddColumnErrorIfRequireIsNot(dr, dataTable.NameColumn);
                
                //  価格が正の数になっていることをチェック。
                RXForValidator.AddColumnError(dr, dataTable.PriceColumn, "価格は正の数でなければなりません。",
                    delegate
                    {
                        return dr.Price < 0;
                    });

                //  価格が整数になっていることをチェック。
                RXForValidator.AddColumnError(dr, dataTable.PriceColumn, "価格は整数でなければなりません。",
                    delegate
                    {
                        return dr.Price != Math.Round(dr.Price);
                    });

                //  在庫数量が正の数になっていることをチェック。
                RXForValidator.AddColumnError(dr, dataTable.QuantityColumn, "在庫数量は正の数でなければなりません。",
                    delegate
                    {
                        return dr.Quantity < 0;
                    });
            }
        }
    }
}
