﻿using System;
using TailIsland.RX;

namespace TailIsland.PetShop.RetailServiceAgent
{
    public static class ProductValidator
    {
        public static void Validate(RetailDataSet.ProductDataTable dataTable)
        {
            foreach (RetailDataSet.ProductRow dr in RXForValidator.GetAddedOrModifiedRows(dataTable))
            {
                //  必須チェック。
                RXForValidator.AddColumnErrorIfRequireIsNot(dr, dataTable.NameColumn);
                RXForValidator.AddColumnErrorIfRequireIsNot(dr, dataTable.DescriptionColumn);

                //  品目の存在をチェック。
                RXForValidator.AddRowError(dr, "商品には最低一つの品目が必要です。",
                    delegate
                    {
                        return dr.GetItemRows().Length == 0;
                    });
            }
        }
    }
}
