﻿using System;
using System.ComponentModel;
using System.Web;
using System.Web.Services;
using TailIsland.RX;
using TailIsland.PetShop.Retail;

namespace TailIsland.PetShop.RetailServiceInterface
{
    [WebService(Namespace = "http://tailisland.com/PetShop/RetailServiceInterface")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [ToolboxItem(false)]
    public class ProductWebService : WebService
    {
        [WebMethod]
        public RetailDataSet Update(RetailDataSet dataSet)
        {
            if (dataSet == null)
            {
                throw new ArgumentNullException("dataSet");
            }

            RXForWebService.ExecuteWebService(
                delegate
                {
                    Product.Update(dataSet);
                });

            return dataSet;
        }

        [WebMethod]
        public RetailDataSet FillByCategoryIdentityWithChildren(long categoryIdentity)
        {
            RetailDataSet ds = new RetailDataSet();

            RXForWebService.ExecuteWebService(
                delegate
                {
                    Product.FillByCategoryIdentityWithChildren(ds, categoryIdentity);
                });

            return ds;
        }
    }
}
