﻿<%@ Page Language="C#" MasterPageFile="~/Resources/StoreFrontMaster.Master" AutoEventWireup="true" CodeBehind="UserInformationWebForm.aspx.cs" Inherits="TailIsland.PetShop.StoreFront.Account.UserInformationWebForm" Title="ユーザー登録" %>

<asp:Content ID="content" ContentPlaceHolderID="contentPlaceHolder" runat="server">
    <table border="0" cellpadding="4" cellspacing="0" style="width: 100%;">
        <thead>
            <tr>
                <th colspan="3" style="background-color: #888888; color: #ffffff;">ユーザー登録</th> 
                <td>&nbsp;</td>
            </tr>
        </thead>
        <tbody>
            <tr>
                <td style="width: 180px;">ユーザー名</td>
                <td style="width: 12px;">*</td>
                <td style="width: 196px;">
                    <asp:TextBox ID="userNameTextBox" MaxLength="64" Width="196px" runat="server" />
                </td>
                <td style="width: 192px;">
                    <asp:RequiredFieldValidator ID="userNameRequiredFieldValidator" ControlToValidate="userNameTextBox" Display="Dynamic" ErrorMessage="ユーザー名は必須入力項目です。" Text="*" runat="server" />
                </td>
            </tr>
            <tr>
                <td>パスワード</td>
                <td>*</td>
                <td>
                    <asp:TextBox ID="passwordTextBox" MaxLength="64" TextMode="Password" Width="196px" runat="server" />
                </td>
                <td>
                    <asp:RequiredFieldValidator ID="passwordRequiredFieldValidator" ControlToValidate="passwordTextBox" Display="Dynamic" ErrorMessage="パスワードは必須入力項目です。" Text="*" runat="server" />
                </td>
            </tr>
            <tr>
                <td>パスワードの確認</td>
                <td>*</td>
                <td>
                    <asp:TextBox ID="passwordConfirmTextBox" MaxLength="64" TextMode="Password" Width="196px" runat="server" />
                </td>
                <td>
                    <asp:RequiredFieldValidator ID="passwordConfirmRequiredFieldValidator" ControlToValidate="passwordConfirmTextBox" Display="Dynamic" ErrorMessage="パスワードの確認は必須入力項目です。" Text="*" runat="server" />
                    <asp:CompareValidator ID="passwordConfirmCompareValidator" ControlToValidate="passwordConfirmTextBox" ControlToCompare="passwordTextBox" Display="Dynamic" ErrorMessage="パスワードとパスワードの確認には同じ内容を入力してください。" Text="パスワードと一致しません。" runat="server" />
                </td>
            </tr>
            <tr>
                <td>セキュリティの質問</td>
                <td>*</td>
                <td>
                    <asp:TextBox ID="passwordQuestionTextBox" MaxLength="64" Width="196px" runat="server" />
                </td>
                <td>
                    <asp:RequiredFieldValidator ID="passwordQuestionRequiredFieldValidator" ControlToValidate="passwordQuestionTextBox" Display="Dynamic" ErrorMessage="セキュリティの質問は必須入力項目です。" Text="*" runat="server" />
                </td>
            </tr>
            <tr>
                <td>セキュリティの質問への返答</td>
                <td>*</td>
                <td>
                    <asp:TextBox ID="passwordAnswerTextBox" MaxLength="64" Width="196px" runat="server" />
                </td>
                <td>
                    <asp:RequiredFieldValidator ID="passwordAnswerRequiredFieldValidator" ControlToValidate="passwordAnswerTextBox" Display="Dynamic" ErrorMessage="セキュリティの質問への返答は必須入力項目です。" Text="*" runat="server" />
                </td>
            </tr>
            <tr>
                <td>電子メール</td>
                <td>*</td>
                <td>
                    <asp:TextBox ID="eMailTextBox" MaxLength="64" Width="196px" runat="server" />
                </td>
                <td>
                    <asp:RequiredFieldValidator ID="eMailRequiredFieldValidator" ControlToValidate="eMailTextBox" Display="Dynamic" ErrorMessage="電子メールは必須入力項目です。" Text="*" runat="server" />
                    <asp:RegularExpressionValidator ID="eMailRegularExpressionValidator" ControlToValidate="eMailTextBox" Display="Dynamic" ErrorMessage="電子メールは正しい形式で入力してください。" ValidationExpression="\w+([-+.']\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*" Text="userid@company.co.jp" runat="server" />
                </td>
            </tr>
            <tr>
                <td>郵便番号</td>
                <td>*</td>
                <td>
                    <asp:TextBox ID="zipCodeTextBox" MaxLength="20" Width="196px" runat="server" />
                </td>
                <td>
                    <asp:RequiredFieldValidator ID="zipCodeRequiredFieldValidator" ControlToValidate="zipCodeTextBox" Display="Dynamic" ErrorMessage="郵便番号は必須入力項目です。" Text="*" runat="server" />
                    <asp:RegularExpressionValidator ID="zipCodeRegularExpressionValidator" ControlToValidate="zipCodeTextBox" Display="Dynamic" ErrorMessage="郵便番号は半角数字3桁と「-（半角ハイフン）」、半角数字4桁で入力してください。" Text="###-####" ValidationExpression="[0-9]{3}-[0-9]{4}" runat="server" />
                </td>
            </tr>
            <tr>
                <td>住所1</td>
                <td>*</td>
                <td>
                    <asp:TextBox ID="address1TextBox" MaxLength="64" Width="196px" runat="server" />
                </td>
                <td>
                    <asp:RequiredFieldValidator ID="address1RequiredFieldValidator" ControlToValidate="address1TextBox" Display="Dynamic" ErrorMessage="住所1は必須入力項目です。" Text="*" runat="server" />
                </td>
            </tr>
            <tr>
                <td>住所2</td>
                <td>&nbsp;</td>
                <td>
                    <asp:TextBox ID="address2TextBox" MaxLength="64" Width="196px" runat="server" />
                </td>
                <td>&nbsp;</td>
            </tr>
            <tr>
                <td>電話番号</td>
                <td>*</td>
                <td>
                    <asp:TextBox ID="phoneNumberTextBox" MaxLength="20" Width="196px" runat="server" />
                </td>
                <td>
                    <asp:RequiredFieldValidator ID="phoneNumberRequiredFieldValidator" ControlToValidate="phoneNumberTextBox" Display="Dynamic" ErrorMessage="電話番号は必須入力項目です。" Text="*" runat="server" />
                    <asp:RegularExpressionValidator ID="phoneNumberRegularExpressionValidator" ControlToValidate="phoneNumberTextBox" Display="Dynamic" ErrorMessage="電話番号は半角数字および「-（半角ハイフン）」で入力してください。" Text="###-####-####" ValidationExpression="[0-9\-]+" runat="server" />
                </td>
            </tr>
            <tr>
                <td>氏名</td>
                <td>*</td>
                <td>
                    <asp:TextBox ID="nameTextBox" MaxLength="64" Width="196px" runat="server" />
                </td>
                <td>
                    <asp:RequiredFieldValidator ID="nameRequiredFieldValidator" ControlToValidate="nameTextBox" Display="Dynamic" ErrorMessage="氏名は必須入力項目です。" Text="*" runat="server" />
                </td>
            </tr>
            <tr>
                <td colspan="3" style="text-align: right;">
                    <asp:Button ID="createUserButton" Text="ユーザーを登録する" OnClick="createUserButton_Click" runat="server" />
                </td>
            </tr>
        </tbody>
    </table>
    <asp:ValidationSummary ID="validationSummary" runat="server" />
    <p>
        <asp:Label ID="errorLabel" ForeColor="Red" runat="server" />
    </p> 
</asp:Content>
