﻿using System;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using TailIsland.RX;
using TailIsland.PetShop.Retail;

namespace TailIsland.PetShop.StoreFront.Account
{
    /// <summary>
    ///    利用者情報のためのWebFormです。
    /// </summary>
    public partial class UserInformationWebForm : Page
    {
        /// <summary>
        ///    [ユーザーを登録する]ボタンがクリックされた場合のイベント・ハンドラです。
        /// </summary>
        /// <param name="sender">イベントの送信元。</param>
        /// <param name="e">イベント。</param>
        protected void createUserButton_Click(object sender, EventArgs e)
        {
            RXForWebForm.ExecuteEventHandler(
                delegate
                {
                    try
                    {
                        //  利用者を作成します。
                        UserInformation.CreateUserInformation(
                            userNameTextBox.Text, passwordTextBox.Text, eMailTextBox.Text, passwordQuestionTextBox.Text, passwordAnswerTextBox.Text,
                            zipCodeTextBox.Text, address1TextBox.Text, address2TextBox.Text, phoneNumberTextBox.Text, nameTextBox.Text);

                        //  遷移元のページにリダイレクトします。
                        Response.Redirect(Request.QueryString["ReturnUrl"]);
                    }
                    //  Membershipフレームワークを使用しているので、利用者の追加では例外が発生します。
                    catch (MembershipCreateUserException ex)
                    {
                        //  例外の内容を画面に表示します。
                        errorLabel.Text = HttpUtility.HtmlEncode(ex.Message);
                    }
                });
        }
    }
}
