﻿<%@ Page Language="C#" MasterPageFile="~/Resources/StoreFrontMaster.Master" AutoEventWireup="true" CodeBehind="ItemsWebForm.aspx.cs" Inherits="TailIsland.PetShop.StoreFront.Catalog.ItemsWebForm" Title="品目一覧" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="TailIsland.PetShop.Retail" %>

<asp:Content ID="content" ContentPlaceHolderID="contentPlaceHolder" runat="server">
    <table border="0px" cellpadding="4px" cellspacing="0px" style="width: 100%;">
        <thead>
            <tr>
                <th colspan="2" style="background-color: #888888; color: #ffffff;">商品「<asp:Label ID="productNameLabel1" Text="<%# HttpUtility.HtmlEncode(RetailDataSet.Product[0].Name) %>" runat="server" />」の品目一覧</th> 
            </tr>  
            <tr>
                <td rowspan="2" style="width: 125px;">
                    <asp:Image ID="productPhotographImage" AlternateText='<%# HttpUtility.HtmlEncode(RetailDataSet.Product[0].Name) %>' ImageUrl='<%# HttpUtility.HtmlEncode(string.Format("PhotographWebForm.aspx?photographNumber={0}", HttpUtility.UrlEncode(RetailDataSet.Product[0].PhotographNumber.ToString()))) %>' runat="server" />
                </td> 
                <td style="vertical-align: bottom; width: 467px;">
                    <asp:Label ID="productNameLabel2" Text='<%# HttpUtility.HtmlEncode(RetailDataSet.Product[0].Name) %>' runat="server" />
                </td>
            </tr>
            <tr>
                <td style="vertical-align: top;">
                    <asp:Label ID="productDescriptionLabel" Text='<%# HttpUtility.HtmlEncode(RetailDataSet.Product[0].Description) %>' runat="server" />
                </td>
            </tr> 
        </thead>  
        <tbody>
            <tr>
                <td colspan="2">
                    <table border="0px" cellpadding="0px" cellspacing="0px" style="width: 100%">
                        <tbody>
                            <asp:Repeater ID="itemRepeater" DataSource="<%# RetailDataSet %>" DataMember="Item" OnItemCommand="itemRepeater_ItemCommand" runat="server">
                                <ItemTemplate>
                                    <tr>
                                        <td>
                                            <asp:Label ID="itemNameLabel" Text='<%# HttpUtility.HtmlEncode(Eval("Name", "{0}")) %>' runat="server" />
                                        </td>
                                        <td>
                                            <asp:Label ID="itemPriceLabel" Text='<%# HttpUtility.HtmlEncode(Eval("Price", "{0:c}")) %>' runat="server" />
                                        </td>
                                        <td>
                                            在庫:&nbsp;
                                            <asp:Label ID="itemNotReservedQuantityLabel" Text='<%# HttpUtility.HtmlEncode(((RetailDataSet.ItemRow)((DataRowView)Container.DataItem).Row).Quantity > 10 ? "○" : ((RetailDataSet.ItemRow)((DataRowView)Container.DataItem).Row).Quantity > 0 ? "△" : "×") %>' runat="server" />
                                        </td>
                                        <td style="text-align: right;">
                                            <asp:Button ID="moveToShoppingCartButton" CommandName="Select" CommandArgument='<%# HttpUtility.HtmlEncode(Eval("Identity", "{0}")) %>' Enabled="<%# ((RetailDataSet.ItemRow)((DataRowView)Container.DataItem).Row).Quantity > 0 %>" Text="ショッピング・カートに入れる" runat="server" />
                                        </td> 
                                    </tr> 
                                </ItemTemplate> 
                            </asp:Repeater>
                        </tbody>
                    </table>
                </td>  
            </tr> 
        </tbody>  
    </table>
</asp:Content>
