﻿using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using TailIsland.RX;
using TailIsland.PetShop.Retail;

namespace TailIsland.PetShop.StoreFront.Catalog
{
    /// <summary>
    ///    品目のWebFormです。
    /// </summary>
    public partial class ItemsWebForm : Page
    {
        /// <summary>
        ///    RetailDataSet。
        /// </summary>
        private RetailDataSet retailDataSet;

        /// <summary>
        ///    RetailDataSetを取得/設定します。
        /// </summary>
        protected RetailDataSet RetailDataSet
        {
            get { return retailDataSet; }
            set { retailDataSet = value; }
        }

        /// <summary>
        ///    ページがロードされた時のイベント・ハンドラです。
        /// </summary>
        /// <param name="sender">イベントの送信元。</param>
        /// <param name="e">イベント。</param>
        protected void Page_Load(object sender, EventArgs e)
        {
            RXForWebForm.ExecuteEventHandler(
                delegate
                {
                    //  ポスト・バックでなければ……。
                    if (!IsPostBack)
                    {
                        //  品目を取得します。
                        RetailDataSet = new RetailDataSet();
                        Item.FillByProductIdentity(RetailDataSet, Convert.ToInt64(Request["productIdentity"]));

                        //  データ・バインディングを実行します。
                        DataBind();
                    }
                });
        }

        /// <summary>
        ///    品目のRepeaterでコマンドが発行されたときのイベント・ハンドラです。
        /// </summary>
        /// <param name="source">イベントの送信元。</param>
        /// <param name="e">イベント。</param>
        protected void itemRepeater_ItemCommand(object source, RepeaterCommandEventArgs e)
        {
            RXForWebForm.ExecuteEventHandler(
                delegate
                {
                    //  コマンド名が選択だったら……。
                    if (e.CommandName == "Select")
                    {
                        //  OrderDetailsWebFormにリダイレクトします。
                        Response.Redirect(string.Format("../Purchase/OrderDetailsWebForm.aspx?itemIdentity={0}", HttpUtility.UrlEncode((string)e.CommandArgument)));
                    }
                });
        }
    }
}
