﻿using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using TailIsland.RX;
using TailIsland.PetShop.Retail;

namespace TailIsland.PetShop.StoreFront.Catalog
{
    /// <summary>
    ///    商品一覧のためのWebFormです。
    /// </summary>
    public partial class ProductsWebForm : Page
    {
        /// <summary>
        ///    RetailDataSet。
        /// </summary>
        private RetailDataSet retailDataSet;

        /// <summary>
        ///    RetailDataSetを取得/設定します。
        /// </summary>
        protected RetailDataSet RetailDataSet
        {
            get { return retailDataSet; }
            set { retailDataSet = value; }
        }

        /// <summary>
        ///    ページがロードされた時のイベント・ハンドラです。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Page_Load(object sender, EventArgs e)
        {
            RXForWebForm.ExecuteEventHandler(
                delegate
                {
                    //  ポスト・バックでなければ……。
                    if (!IsPostBack)
                    {
                        //  商品を取得します。
                        RetailDataSet = new RetailDataSet();
                        Product.FillByCategoryIdentity(RetailDataSet, Convert.ToInt64(Request["categoryIdentity"]));

                        //  データ・バインディングを実行します。
                        DataBind();
                    }
                });
        }

        /// <summary>
        ///    商品のRepeaterでコマンドが発行された時のイベント・ハンドラです。
        /// </summary>
        /// <param name="source">イベントの発信元。</param>
        /// <param name="e">イベント。</param>
        protected void productRepeater_ItemCommand(object source, RepeaterCommandEventArgs e)
        {
            RXForWebForm.ExecuteEventHandler(
                delegate
                {
                    //  コマンド名が選択の場合は……。
                    if (e.CommandName == "Select")
                    {
                        //  ItemsWebFormにリダイレクトします。
                        Response.Redirect(string.Format("../Catalog/ItemsWebForm.aspx?productIdentity={0}", HttpUtility.UrlEncode((string)e.CommandArgument)));
                    }
                });
        }
    }
}
