﻿using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using TailIsland.RX;
using TailIsland.PetShop.Retail;

namespace TailIsland.PetShop.StoreFront
{
    /// <summary>
    ///    デフォルト・ページです。
    /// </summary>
    public partial class _Default : Page
    {
        /// <summary>
        ///    ページ・ロードの時のイベント・ハンドラです。
        /// </summary>
        /// <param name="sender">イベントの送信元。</param>
        /// <param name="e">イベント。</param>
        protected void Page_Load(object sender, EventArgs e)
        {
            RXForWebForm.ExecuteEventHandler(
                delegate
                {
                    //  ポスト・バックでなければ……。
                    if (!IsPostBack)
                    {
                        //  カタログ・ページにリダイレクトします。
                        Response.Redirect(string.Format("Catalog/ProductsWebForm.aspx?categoryIdentity={0}", GetDefaultCategoryIdentity()));
                    }
                });
        }

        /// <summary>
        ///    デフォルトのカテゴリーを取得します。
        /// </summary>
        /// <returns>デフォルトのカテゴリーの識別子。</returns>
        private static long GetDefaultCategoryIdentity()
        {
            //  RDBMSから、現在存在するカテゴリーを取得します。
            RetailDataSet ds = new RetailDataSet();
            Category.Fill(ds);

            //  最初のカテゴリーをデフォルトとして扱います。
            return ds.Category[0].Identity;
        }
    }
}
