﻿using System;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using TailIsland.RX;
using TailIsland.PetShop.Retail;

namespace TailIsland.PetShop.StoreFront
{
    /// <summary>
    ///    ログインのためのWebFormです。
    /// </summary>
    public partial class Login : Page
    {
        /// <summary>
        ///    ページがロードされた時のイベント・ハンドラです。
        /// </summary>
        /// <param name="sender">イベントの送信元。</param>
        /// <param name="e">イベント。</param>
        protected void Page_Load(object sender, EventArgs e)
        {
            RXForWebForm.ExecuteEventHandler(
                delegate
                {
                    //  ポストバックでなければ……。
                    if (!IsPostBack)
                    {
                        //  ログイン・コントロールにフォーカスを当てます。
                        aLogin.Focus();
                    }
                });
        }

        /// <summary>
        ///    ログインの時のイベント・ハンドラです。
        /// </summary>
        /// <param name="sender">イベントの送信元。</param>
        /// <param name="e">イベント。</param>
        protected void aLogin_LoggedIn(object sender, EventArgs e)
        {
            RXForWebForm.ExecuteEventHandler(
                delegate
                {
                    //  念のため、予約を削除します。
                    ReservedItem.Clear((Guid)Membership.GetUser(aLogin.UserName).ProviderUserKey);

                    //  念のため、セッションを削除します。
                    Session.Remove("Tailsland.PetShop.StoreFront.Purchase.RetailDataSet");
                });
        }

        /// <summary>
        ///    ユーザ登録リンク・ボタンがクリックされた時のイベント・ハンドラです。
        /// </summary>
        /// <param name="sender">イベントの送信元。</param>
        /// <param name="e">イベント。</param>
        protected void registerUserLinkButton_Click(object sender, EventArgs e)
        {
            RXForWebForm.ExecuteEventHandler(
                delegate
                {
                    //  遷移元のWebFormにリダイレクトします。
                    Response.Redirect(string.Format("./Account/UserInformationWebForm.aspx?ReturnUrl={0}", HttpUtility.HtmlEncode(Request.QueryString["ReturnUrl"])));
                });
        }
    }
}
