﻿<%@ Page Language="C#" MasterPageFile="~/Resources/StoreFrontMaster.Master" AutoEventWireup="true" CodeBehind="OrderDetailsWebForm.aspx.cs" Inherits="TailIsland.PetShop.StoreFront.Purchase.OrderDetailsWebForm" Title="ショッピング・カート" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="TailIsland.PetShop.Retail" %>

<asp:Content ID="content" ContentPlaceHolderID="contentPlaceHolder" runat="server">
    <table border="0px" cellpadding="4px" cellspacing="0px" style="width: 100%;">
        <thead>
            <tr>
                <th colspan="5" style="background-color: #888888; color: #ffffff;">ショッピング・カート</th> 
            </tr>
            <tr>
                <th style="background-color: #eeeeee;">商品</th>
                <th style="background-color: #eeeeee;">品目</th>
                <th style="background-color: #eeeeee;">数量</th>
                <th style="background-color: #eeeeee; text-align: right;">金額</th>
                <th style="background-color: #eeeeee;">&nbsp;</th>
            </tr> 
        </thead>  
        <tbody>
            <asp:Repeater ID="orderDetailRepeater" DataSource="<%# RetailDataSet %>" DataMember="OrderDetail" OnItemCommand="orderDetailRepeater_ItemCommand" runat="server">
                <ItemTemplate>
                    <tr>
                        <td>
                            <asp:Label ID="ProductNameLabel" Text="<%# HttpUtility.HtmlEncode(((RetailDataSet.OrderDetailRow)((DataRowView)Container.DataItem).Row).ItemRow.ProductRow.Name) %>" runat="server" />
                        </td>
                        <td>
                            <asp:Label ID="itemNameLabel" Text="<%# HttpUtility.HtmlEncode(((RetailDataSet.OrderDetailRow)((DataRowView)Container.DataItem).Row).ItemRow.Name) %>" runat="server" />
                        </td>
                        <td>
                            <asp:TextBox ID="orderDetailQuantityTextBox" Columns="2" MaxLength="2"  Text='<%# HttpUtility.HtmlEncode(Eval("Quantity", "{0}")) %>' runat="server" /> 
                            <asp:RequiredFieldValidator ID="orderDetailQuantityRequiredFieldValidator" ControlToValidate="orderDetailQuantityTextBox" Display="Dynamic" ErrorMessage="数量は必須入力項目です。" Text="*" runat="server" />
                            <asp:RegularExpressionValidator ID="orderDetailQuantityRegularExpressionValidator" ControlToValidate="orderDetailQuantityTextBox" Display="Dynamic" ErrorMessage="数量は数字で入力してください。" Text="##" ValidationExpression="[0-9]*" runat="server" />
                            <asp:Button ID="changeQuantityButton" CommandName="Update" CommandArgument='<%# HttpUtility.HtmlEncode(Eval("Identity", "{0}")) %>' Text="変更" runat="server" />
                        </td>
                        <td style="text-align: right;">
                            <asp:Label ID="orderDetailPriceLabel" Text='<%# HttpUtility.HtmlEncode(Eval("Price", "{0:c}")) %>' runat="server" />
                        </td>
                        <td style="text-align: right;">
                            <asp:Button ID="deleteOrderDetailButton" CausesValidation="false" CommandName="Delete" CommandArgument='<%# HttpUtility.HtmlEncode(Eval("Identity", "{0}")) %>' Text="取消" runat="server" />
                        </td>
                    </tr>
                </ItemTemplate> 
            </asp:Repeater>
        </tbody>  
        <tfoot>
            <tr>
                <td colspan="3" style="background-color: #eeeeee;">&nbsp;</td> 
                <td style="background-color: #eeeeee; text-align: right;">
                    <asp:Label ID="totalPriceLabel" Text='<%# HttpUtility.HtmlEncode(string.Format("{0:c}", TotalPrice)) %>' runat="server" />
                </td>
                <td style="background-color: #eeeeee;">&nbsp;</td>
            </tr>
            <tr>
                <td colspan="5" style="text-align: right;">
                    <asp:Button ID="goToRegister" Enabled="<%# RetailDataSet.OrderDetail.Count > 0 %>" Text="レジに進む" OnClick="goToRegister_Click" runat="server" />
                </td> 
            </tr>
        </tfoot>
    </table>
    <asp:ValidationSummary ID="validationSummary" runat="server" /> 
    <p>
        <asp:Label ID="errorLabel" ForeColor="Red" runat="server" />
    </p> 
</asp:Content>
