﻿using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using TailIsland.RX;
using TailIsland.PetShop.Retail;

namespace TailIsland.PetShop.StoreFront.Purchase
{
    /// <summary>
    ///    注文結果のためのWebFormです。
    /// </summary>
    public partial class OrderResultWebForm : Page
    {
        /// <summary>
        ///    RetailDataSetを取得/設定します。データはセッションを利用して保持します。
        /// </summary>
        protected RetailDataSet RetailDataSet
        {
            get { return (RetailDataSet)Session["TailIsland.PetShop.StoreFront.Purchase.RetailDataSet"]; }
            set { Session["TailIsland.PetShop.StoreFront.Purchase.RetailDataSet"] = value; }
        }

        /// <summary>
        ///    ページがロードされた時のイベント・ハンドラです。
        /// </summary>
        /// <param name="sender">イベントの送信元。</param>
        /// <param name="e">イベント。</param>
        protected void Page_Load(object sender, EventArgs e)
        {
            RXForWebForm.ExecuteEventHandler(
                delegate
                {
                    //  ポスト・バックでなければ……。
                    if (!IsPostBack)
                    {
                        //  RetailDataSetが保持されている場合は……。
                        if (RetailDataSet != null && RetailDataSet.Order.Count > 0)
                        {
                            //  データ・バインディングを実行します。
                            DataBind();
                        }
                    }
                });
        }

        /// <summary>
        ///    [トップページに移動する]ボタンがクリックされた時のイベント・ハンドラです。
        /// </summary>
        /// <param name="sender">イベントの送信元。</param>
        /// <param name="e">イベント。</param>
        protected void goToTopPageButton_Click(object sender, EventArgs e)
        {
            RXForWebForm.ExecuteEventHandler(
                delegate
                {
                    //  セッションを削除します。
                    Session.Remove("TailIsland.PetShop.StoreFront.Purchase.RetailDataSet");

                    //  トップ・ページにリダイレクトします。
                    Response.Redirect("../Default.aspx");
                });
        }
    }
}
