﻿<%@ Page Language="C#" MasterPageFile="~/Resources/StoreFrontMaster.Master" AutoEventWireup="true" CodeBehind="OrderWebForm.aspx.cs" Inherits="TailIsland.PetShop.StoreFront.Purchase.OrderWebForm" Title="注文" %>

<asp:Content ID="content" ContentPlaceHolderID="contentPlaceHolder" runat="server">
    <table border="0" cellpadding="4" cellspacing="0" style="width: 100%;">
        <thead>
            <tr>
                <th colspan="2" style="background-color: #888888; color: #ffffff;">注文</th> 
                <td>&nbsp;</td>
            </tr>
        </thead>
        <tbody>
            <tr>
                <td style="width: 196px;">郵便番号</td>
                <td style="width: 196px;">
                    <asp:TextBox ID="shippingZipCodeTextBox" MaxLength="20" Text="<%# RetailDataSet.Order[0].ShippingZipCode %>" Width="196px" runat="server" />
                </td>
                <td style="width: 192px;">
                    <asp:RequiredFieldValidator ID="shippingZipCodeRequiredFieldValidator" ControlToValidate="shippingZipCodeTextBox" Display="Dynamic" ErrorMessage="郵便番号は必須入力項目です。" Text="*" runat="server" />
                    <asp:RegularExpressionValidator ID="shippingZipCodeRegularExpressionValidator" ControlToValidate="shippingZipCodeTextBox" Display="Dynamic" ErrorMessage="郵便番号は半角数字3桁と「-（半角ハイフン）」、半角数字4桁で入力してください。" Text="###-####" ValidationExpression="[0-9]{3}-[0-9]{4}" runat="server" />
                </td>
            </tr>
            <tr>
                <td>住所1</td>
                <td>
                    <asp:TextBox ID="shippingAddress1TextBox" MaxLength="64" Text="<%# RetailDataSet.Order[0].ShippingAddress1 %>" Width="196px" runat="server" />
                </td>
                <td>
                    <asp:RequiredFieldValidator ID="shippingAddress1RequiredFieldValidator" ControlToValidate="shippingAddress1TextBox" Display="Dynamic" ErrorMessage="住所1は必須入力項目です。" Text="*" runat="server" />
                </td>
            </tr>
            <tr>
                <td>住所2</td>
                <td>
                    <asp:TextBox ID="shippingAddress2TextBox" MaxLength="64" Text="<%# RetailDataSet.Order[0].ShippingAddress2 %>" Width="196px" runat="server" />
                </td>
                <td>&nbsp;</td>
            </tr>
            <tr>
                <td>電話番号</td>
                <td>
                    <asp:TextBox ID="shippingPhoneNumberTextBox" MaxLength="20" Text="<%# RetailDataSet.Order[0].ShippingPhoneNumber %>" Width="196px" runat="server" />
                </td>
                <td>
                    <asp:RequiredFieldValidator ID="shippingPhoneNumberRequiredFieldValidator" ControlToValidate="shippingPhoneNumberTextBox" Display="Dynamic" ErrorMessage="電話番号は必須入力項目です。" Text="*" runat="server" />
                    <asp:RegularExpressionValidator ID="shippingPhoneNumberRegularExpressionValidator" ControlToValidate="shippingPhoneNumberTextBox" Display="Dynamic" ErrorMessage="電話番号は半角数字および「-（半角ハイフン）」で入力してください。" Text="###-####-####" ValidationExpression="[0-9\-]+" runat="server" />
                </td>
            </tr>
            <tr>
                <td>氏名</td>
                <td>
                    <asp:TextBox ID="shippingNameTextBox" MaxLength="64" Text="<%# RetailDataSet.Order[0].ShippingName %>" Width="196px" runat="server" />
                </td>
                <td>
                    <asp:RequiredFieldValidator ID="shippingNameRequiredFieldValidator" ControlToValidate="shippingNameTextBox" Display="Dynamic" ErrorMessage="氏名は必須入力項目です。" Text="*" runat="server" />
                </td>
            </tr>
            <tr>
                <td>クレジット・カード会社</td>
                <td>
                    <asp:DropDownList ID="creditCardCompanyDropDownList" Width="196px" runat="server">
                        <asp:ListItem>-</asp:ListItem>
                        <asp:ListItem>JCB</asp:ListItem>
                        <asp:ListItem>MasterCard</asp:ListItem>
                        <asp:ListItem>VISA</asp:ListItem>
                    </asp:DropDownList>
                </td>
                <td>
                    <asp:RegularExpressionValidator ID="creditCardCompanyRegularExpressionValidator" ControlToValidate="creditCardCompanyDropDownList" Display="Dynamic" ErrorMessage="クレジット・カード会社を選択してください。" Text="*" ValidationExpression="[^\-]+" runat="server" />
                </td>
            </tr>
            <tr>
                <td>クレジット・カード番号</td>
                <td>
                    <asp:TextBox ID="creditCardNumberTextBox" Width="196px" runat="server" />
                </td>
                <td>
                    <asp:RequiredFieldValidator ID="creditCardNumberRequiredFieldValidator" ControlToValidate="creditCardNumberTextBox" Display="Dynamic" ErrorMessage="クレジット・カード番号は必須入力項目です。" Text="*" runat="server" />
                    <asp:RegularExpressionValidator ID="creditCardNumberRegularExpressionValidator" ControlToValidate="creditCardNumberTextBox" Display="Dynamic" ErrorMessage="クレジット・カード番号は半角数字で入力してください。「-（半角ハイフン）」は入力しないでください。" Text="####" ValidationExpression="[0-9]+" runat="server" />
                </td>
            </tr>
            <tr>
                <td>
                    クレジット・カード有効期限</td>
                <td>
                    <asp:DropDownList ID="creditCardExpireMonthDropDownList" runat="server">
                        <asp:ListItem>-</asp:ListItem>
                        <asp:ListItem>01</asp:ListItem>
                        <asp:ListItem>02</asp:ListItem>
                        <asp:ListItem>03</asp:ListItem>
                        <asp:ListItem>04</asp:ListItem>
                        <asp:ListItem>05</asp:ListItem>
                        <asp:ListItem>06</asp:ListItem>
                        <asp:ListItem>07</asp:ListItem>
                        <asp:ListItem>08</asp:ListItem>
                        <asp:ListItem>09</asp:ListItem>
                        <asp:ListItem>10</asp:ListItem>
                        <asp:ListItem>11</asp:ListItem>
                        <asp:ListItem>12</asp:ListItem>
                    </asp:DropDownList>
                    月
                    <asp:DropDownList ID="creditCardExpireYearDropDownList" runat="server">
                        <asp:ListItem>-</asp:ListItem>
                    </asp:DropDownList>
                    年
                </td>
                <td>
                    <asp:RegularExpressionValidator ID="creditCardExpireMonthRegularExpressionValidator" ControlToValidate="creditCardExpireMonthDropDownList" Display="Dynamic" ErrorMessage="クレジット・カード有効期限（月）を選択してください。" Text="*" ValidationExpression="[^\-]+" runat="server" />
                    <asp:RegularExpressionValidator ID="creditCardExpireYearRegularExpressionValidator" ControlToValidate="creditCardExpireYearDropDownList" Display="Dynamic" ErrorMessage="クレジット・カード有効期限（年）を選択してください。" Text="*" ValidationExpression="[^\-]+" runat="server" />
                </td>
            </tr>
        </tbody>  
        <tfoot>
            <tr>
                <td colspan="2" style="text-align: right;">
                    <asp:Button ID="purchaseButton" Text="購入を確定する" OnClick="purchaseButton_Click" runat="server" />
                </td>
                <td>&nbsp;</td>
            </tr>
        </tfoot>
    </table>
    <asp:ValidationSummary ID="validationSummary" runat="server" />
    <p>
        <asp:Label ID="errorLabel" ForeColor="Red" runat="server" />
    </p> 
</asp:Content>
