﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace TailIsland.RX.Test
{
    [TestClass]
    public class JisX0208CheckerUnitTest
    {
        [TestMethod]
        public void CheckJisX0208()
        {
            string s;

            Assert.IsTrue(new TailIsland_RX_JisX0208CheckerAccessor(TailIsland_RX_JisX0208CheckerAccessor.CreatePrivate("\t\r\n")).CheckJisX0208(out s));
            Assert.AreEqual(string.Empty, s);

            Assert.IsTrue(new TailIsland_RX_JisX0208CheckerAccessor(TailIsland_RX_JisX0208CheckerAccessor.CreatePrivate("￠￡￢―∥－～")).CheckJisX0208(out s));
            Assert.AreEqual(string.Empty, s);

            Assert.IsTrue(new TailIsland_RX_JisX0208CheckerAccessor(TailIsland_RX_JisX0208CheckerAccessor.CreatePrivate("\u00a2\u00a3\u00ac\u2014\u2016\u2212\u301c")).CheckJisX0208(out s));
            Assert.AreEqual(string.Empty, s);

            Assert.IsTrue(new TailIsland_RX_JisX0208CheckerAccessor(TailIsland_RX_JisX0208CheckerAccessor.CreatePrivate("あいうえお尾島良司")).CheckJisX0208(out s));
            Assert.AreEqual(string.Empty, s);

            Assert.IsFalse(new TailIsland_RX_JisX0208CheckerAccessor(TailIsland_RX_JisX0208CheckerAccessor.CreatePrivate("かきくけこ森鷗外")).CheckJisX0208(out s));
            Assert.AreEqual("鷗", s);
        }
    }
}
