﻿using System;
using System.Collections.Generic;
using System.Data;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace TailIsland.RX.Test
{
    [TestClass()]
    public class ModifiedAndDeletedRowsLockerUnitTest
    {
        [TestInitialize]
        public void TestInitialize()
        {
            RXForUnitTest.ExecuteCreateSqlScript("PetShop", "TailIsland.RX");
            RXForUnitTest.ExecuteChangeSqlScript("PetShop", "TailIsland.RX");
        }

        [TestCleanup]
        public void TestCleanup()
        {
            RXForUnitTest.ExecuteCreateSqlScript("PetShop", "TailIsland.RX-drop");
        }

        [TestMethod()]
        public void GetLockCommands()
        {
            using (RXDataSet ds = new RXDataSet())
            {
                RXForBusiness.CallFillTableAdaptersWithChildren(ds.T11, string.Empty);

                ds.T11[0].Delete();
                ds.T11[1].Value = "X";
                ds.T12[0].Value = "Y";
                ds.T12[1].Delete();

                List<DataTable> l1 = new List<DataTable>();

                l1.Add(ds.T11);
                l1.Add(ds.T12);

                List<string> l2 = new List<string>(TailIsland_RX_ModifiedAndDeletedRowsLockerAccessor.GetLockCommands(l1));

                Assert.AreEqual(4, l2.Count);
                Assert.AreEqual("select [PK1], [PK2] from [T12] with (updlock) where [PK1] = 1 and [PK2] = 1", l2[0]);
                Assert.AreEqual("select [PK1], [PK2] from [T12] with (updlock) where [PK1] = 0 and [PK2] = 0", l2[1]);
                Assert.AreEqual("select [PK] from [T11] with (updlock) where [PK] = 1", l2[2]);
                Assert.AreEqual("select [PK] from [T11] with (updlock) where [PK] = 0", l2[3]);
            }
        }
    }
}
