﻿using System;
using System.Collections.Generic;
using System.Data;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace TailIsland.RX.Test
{
    [TestClass]
    public class RelatedDataTablesGetterUnitTest
    {
        [TestInitialize]
        public void TestInitialize()
        {
            RXForUnitTest.ExecuteCreateSqlScript("PetShop", "TailIsland.RX");
            RXForUnitTest.ExecuteChangeSqlScript("PetShop", "TailIsland.RX");
        }

        [ClassCleanup]
        public static void ClassCleanup()
        {
            RXForUnitTest.ExecuteCreateSqlScript("PetShop", "TailIsland.RX-drop");
        }

        [TestMethod]
        public void GetRelatedDataTables()
        {
            using (RXDataSet ds = new RXDataSet())
            {
                List<DataTable> l01 = new List<DataTable>(GetRelatedDataTables(ds.T04,
                    new TailIsland_RX_RelatedDataTablesGetter_ConditionAccessor(0x07),
                    TailIsland_RX_RelatedDataTablesGetter_SortDirectionAccessor.ParentIsFirst));

                Assert.AreEqual(8, l01.Count);

                Assert.AreEqual(ds.T01, l01[0]);
                Assert.AreEqual(ds.T02, l01[1]);
                Assert.AreEqual(ds.T03, l01[2]);
                Assert.AreEqual(ds.T04, l01[3]);
                Assert.AreEqual(ds.T07, l01[4]);
                Assert.AreEqual(ds.T10, l01[5]);
                Assert.AreEqual(ds.T06, l01[6]);
                Assert.AreEqual(ds.T08, l01[7]);

                List<DataTable> l02 = new List<DataTable>(GetRelatedDataTables(ds.T04,
                    new TailIsland_RX_RelatedDataTablesGetter_ConditionAccessor(0x03),
                    TailIsland_RX_RelatedDataTablesGetter_SortDirectionAccessor.ParentIsFirst));

                Assert.AreEqual(7, l02.Count);
                
                Assert.AreEqual(ds.T01, l02[0]);
                Assert.AreEqual(ds.T02, l02[1]);
                Assert.AreEqual(ds.T03, l02[2]);
                Assert.AreEqual(ds.T04, l02[3]);
                Assert.AreEqual(ds.T07, l02[4]);
                Assert.AreEqual(ds.T10, l02[5]);
                Assert.AreEqual(ds.T08, l02[6]);

                List<DataTable> l03 = new List<DataTable>(GetRelatedDataTables(ds.T04,
                    new TailIsland_RX_RelatedDataTablesGetter_ConditionAccessor(0x06),
                    TailIsland_RX_RelatedDataTablesGetter_SortDirectionAccessor.ParentIsFirst));

                Assert.AreEqual(5, l03.Count);
                
                Assert.AreEqual(ds.T04, l03[0]);
                Assert.AreEqual(ds.T07, l03[1]);
                Assert.AreEqual(ds.T10, l03[2]);
                Assert.AreEqual(ds.T06, l03[3]);
                Assert.AreEqual(ds.T08, l03[4]);

                List<DataTable> l04 = new List<DataTable>(GetRelatedDataTables(ds.T04,
                    new TailIsland_RX_RelatedDataTablesGetter_ConditionAccessor(0x05),
                    TailIsland_RX_RelatedDataTablesGetter_SortDirectionAccessor.ParentIsFirst));

                Assert.AreEqual(4, l04.Count);
                
                Assert.AreEqual(ds.T01, l04[0]);
                Assert.AreEqual(ds.T02, l04[1]);
                Assert.AreEqual(ds.T03, l04[2]);
                Assert.AreEqual(ds.T04, l04[3]);

                List<DataTable> l05 = new List<DataTable>(GetRelatedDataTables(ds.T04,
                    new TailIsland_RX_RelatedDataTablesGetter_ConditionAccessor(0x01),
                    TailIsland_RX_RelatedDataTablesGetter_SortDirectionAccessor.ParentIsFirst));

                Assert.AreEqual(4, l05.Count);
                
                Assert.AreEqual(ds.T01, l05[0]);
                Assert.AreEqual(ds.T02, l05[1]);
                Assert.AreEqual(ds.T03, l05[2]);
                Assert.AreEqual(ds.T04, l05[3]);

                List<DataTable> l06 = new List<DataTable>(GetRelatedDataTables(ds.T04,
                    new TailIsland_RX_RelatedDataTablesGetter_ConditionAccessor(0x02),
                    TailIsland_RX_RelatedDataTablesGetter_SortDirectionAccessor.ParentIsFirst));

                Assert.AreEqual(4, l06.Count);
                
                Assert.AreEqual(ds.T04, l06[0]);
                Assert.AreEqual(ds.T07, l06[1]);
                Assert.AreEqual(ds.T10, l06[2]);
                Assert.AreEqual(ds.T08, l06[3]);

                List<DataTable> l07 = new List<DataTable>(GetRelatedDataTables(ds.T04,
                    new TailIsland_RX_RelatedDataTablesGetter_ConditionAccessor(0x04),
                    TailIsland_RX_RelatedDataTablesGetter_SortDirectionAccessor.ParentIsFirst));

                Assert.AreEqual(1, l07.Count);

                Assert.AreEqual(ds.T04, l07[0]);

                List<DataTable> l08 = new List<DataTable>(GetRelatedDataTables(ds.T04,
                    new TailIsland_RX_RelatedDataTablesGetter_ConditionAccessor(0x07),
                    TailIsland_RX_RelatedDataTablesGetter_SortDirectionAccessor.ChildIsFirst));

                Assert.AreEqual(8, l01.Count);

                Assert.AreEqual(ds.T10, l08[0]);
                Assert.AreEqual(ds.T07, l08[1]);
                Assert.AreEqual(ds.T08, l08[2]);
                Assert.AreEqual(ds.T06, l08[3]);
                Assert.AreEqual(ds.T04, l08[4]);
                Assert.AreEqual(ds.T02, l08[5]);
                Assert.AreEqual(ds.T01, l08[6]);
                Assert.AreEqual(ds.T03, l08[7]);

                List<DataTable> l09 = new List<DataTable>(GetRelatedDataTables(ds.T04,
                    new TailIsland_RX_RelatedDataTablesGetter_ConditionAccessor(0x03),
                    TailIsland_RX_RelatedDataTablesGetter_SortDirectionAccessor.ChildIsFirst));

                Assert.AreEqual(7, l09.Count);

                Assert.AreEqual(ds.T10, l09[0]);
                Assert.AreEqual(ds.T07, l09[1]);
                Assert.AreEqual(ds.T08, l09[2]);
                Assert.AreEqual(ds.T04, l09[3]);
                Assert.AreEqual(ds.T02, l09[4]);
                Assert.AreEqual(ds.T01, l09[5]);
                Assert.AreEqual(ds.T03, l09[6]);

                List<DataTable> l10 = new List<DataTable>(GetRelatedDataTables(ds.T04,
                    new TailIsland_RX_RelatedDataTablesGetter_ConditionAccessor(0x06),
                    TailIsland_RX_RelatedDataTablesGetter_SortDirectionAccessor.ChildIsFirst));

                Assert.AreEqual(5, l10.Count);

                Assert.AreEqual(ds.T10, l10[0]);
                Assert.AreEqual(ds.T07, l10[1]);
                Assert.AreEqual(ds.T08, l10[2]);
                Assert.AreEqual(ds.T06, l10[3]);
                Assert.AreEqual(ds.T04, l10[4]);

                List<DataTable> l11 = new List<DataTable>(GetRelatedDataTables(ds.T04,
                    new TailIsland_RX_RelatedDataTablesGetter_ConditionAccessor(0x05),
                    TailIsland_RX_RelatedDataTablesGetter_SortDirectionAccessor.ChildIsFirst));

                Assert.AreEqual(4, l11.Count);

                Assert.AreEqual(ds.T04, l11[0]);
                Assert.AreEqual(ds.T02, l11[1]);
                Assert.AreEqual(ds.T01, l11[2]);
                Assert.AreEqual(ds.T03, l11[3]);

                List<DataTable> l12 = new List<DataTable>(GetRelatedDataTables(ds.T04,
                    new TailIsland_RX_RelatedDataTablesGetter_ConditionAccessor(0x01),
                    TailIsland_RX_RelatedDataTablesGetter_SortDirectionAccessor.ChildIsFirst));

                Assert.AreEqual(4, l12.Count);

                Assert.AreEqual(ds.T04, l12[0]);
                Assert.AreEqual(ds.T02, l12[1]);
                Assert.AreEqual(ds.T01, l12[2]);
                Assert.AreEqual(ds.T03, l12[3]);

                List<DataTable> l13 = new List<DataTable>(GetRelatedDataTables(ds.T04,
                    new TailIsland_RX_RelatedDataTablesGetter_ConditionAccessor(0x02),
                    TailIsland_RX_RelatedDataTablesGetter_SortDirectionAccessor.ChildIsFirst));

                Assert.AreEqual(4, l13.Count);

                Assert.AreEqual(ds.T10, l13[0]);
                Assert.AreEqual(ds.T07, l13[1]);
                Assert.AreEqual(ds.T08, l13[2]);
                Assert.AreEqual(ds.T04, l13[3]);

                List<DataTable> l14 = new List<DataTable>(GetRelatedDataTables(ds.T04,
                    new TailIsland_RX_RelatedDataTablesGetter_ConditionAccessor(0x04),
                    TailIsland_RX_RelatedDataTablesGetter_SortDirectionAccessor.ChildIsFirst));

                Assert.AreEqual(1, l14.Count);

                Assert.AreEqual(ds.T04, l14[0]);
            }
        }

        private static IEnumerable<DataTable> GetRelatedDataTables(DataTable dataTable, TailIsland_RX_RelatedDataTablesGetter_ConditionAccessor condition, TailIsland_RX_RelatedDataTablesGetter_SortDirectionAccessor sortDirection)
        {
            return new TailIsland_RX_RelatedDataTablesGetterAccessor(
                TailIsland_RX_RelatedDataTablesGetterAccessor.CreatePrivate(dataTable, null, condition, sortDirection)).GetRelatedDataTables();
        }
    }
}
