﻿using System;
using System.Data;
using System.Windows.Forms;

namespace TailIsland.RX
{
    internal sealed class BindingSourcePositionGetter
    {
        private BindingSource bindingSource;
        private DataRow currentDataRow;

        internal BindingSourcePositionGetter(BindingSource bindingSource, DataRow currentDataRow)
        {
            this.bindingSource = bindingSource;
            this.currentDataRow = currentDataRow;
        }

        internal int GetBindingSourcePosition()
        {
            for (int i = 0; i < bindingSource.List.Count; ++i)
            {
                if (IsSameDataRow(((DataRowView)bindingSource.List[i]).Row, currentDataRow))
                {
                    return i;
                }
            }

            return -1;
        }

        private static bool IsSameDataRow(DataRow dataRow1, DataRow dataRow2)
        {
            foreach (DataColumn dc in dataRow1.Table.PrimaryKey)
            {
                if (!dataRow1[dc.Ordinal].Equals(dataRow2[dc.Ordinal]))
                {
                    return false;
                }
            }

            return true;
        }
    }
}
