﻿using System;
using System.Data;

namespace TailIsland.RX
{
    internal sealed class ColumnErrorAdder
    {
        private DataRow dataRow;
        private DataColumn dataColumn;
        private string errorMessage;
        private Function<bool> hasError;

        internal ColumnErrorAdder(DataRow dataRow, DataColumn dataColumn, string errorMessage, Function<bool> hasError)
        {
            this.dataRow = dataRow;
            this.dataColumn = dataColumn;
            this.errorMessage = errorMessage;
            this.hasError = hasError;
        }

        internal void AddColumnError()
        {
            if (hasError != null && !hasError())
            {
                return;
            }

            dataRow.SetColumnError(dataColumn, StringUtility.AppendStringAndNewLine(dataRow.GetColumnError(dataColumn), errorMessage));
        }
    }
}
