﻿using System;
using System.Data;
using System.Windows.Forms;

namespace TailIsland.RX
{
    internal sealed class ControlMaxLengthsSetter
    {
        private Control control;
        private DataTable dataTable;

        internal ControlMaxLengthsSetter(Control control, DataTable dataTable)
        {
            this.control = control;
            this.dataTable = dataTable;
        }

        internal void SetControlMaxLengths()
        {
            foreach (Control c in control.Controls)
            {
                new ControlMaxLengthsSetter(c, dataTable).SetControlMaxLengths();

                SetControlMaxLength(c);
            }
        }

        private void SetControlMaxLength(Control targetControl)
        {
            TextBox tb = targetControl as TextBox;

            if (tb != null)
            {
                foreach (DataColumn dc in dataTable.Columns)
                {
                    if (string.Compare(tb.Name.Replace("TextBox", ""), dc.ColumnName, true) == 0 && dc.MaxLength > 0)
                    {
                        tb.MaxLength = dc.MaxLength;
                        break;
                    }
                }
            }
        }
    }
}
