﻿using System;
using System.Data;

namespace TailIsland.RX
{
    internal sealed class DataSetErrorsClearer
    {
        private DataSet dataSet;

        internal DataSetErrorsClearer(DataSet dataSet)
        {
            this.dataSet = dataSet;
        }

        internal void ClearErrors()
        {
            foreach (DataTable dt in dataSet.Tables)
            {
                if (!dt.HasErrors)
                {
                    continue;
                }

                foreach (DataRow dr in dt.Rows)
                {
                    if (!dr.HasErrors)
                    {
                        continue;
                    }

                    dr.ClearErrors();
                }
            }
        }
    }
}
