﻿using System;
using System.Data;

namespace TailIsland.RX
{
    internal sealed class DataSetErrorsCollector
    {
        private DataSet dataSet;

        internal DataSetErrorsCollector(DataSet dataSet)
        {
            this.dataSet = dataSet;
        }

        internal string CollectDataSetErrors()
        {
            string s = string.Empty;

            if (dataSet.HasErrors)
            {
                foreach (DataTable dt in dataSet.Tables)
                {
                    if (dt.HasErrors)
                    {
                        foreach (DataRow dr in dt.Rows)
                        {
                            if (dr.HasErrors)
                            {
                                if (!string.IsNullOrEmpty(dr.RowError))
                                {
                                    s = StringUtility.AppendStringAndNewLine(s, dr.RowError);
                                }

                                foreach (DataColumn dc in dt.Columns)
                                {
                                    if (!string.IsNullOrEmpty(dr.GetColumnError(dc)))
                                    {
                                        s = StringUtility.AppendStringAndNewLine(s, dr.GetColumnError(dc));
                                    }
                                }
                            }
                        }
                    }
                }
            }

            return s;
        }
    }
}
