﻿using System;
using System.Diagnostics;
using System.Web.Services.Protocols;
using System.Windows.Forms;

namespace TailIsland.RX
{
    internal sealed class FormEventHandlerExecutor
    {
        private Procedure procedure;

        internal FormEventHandlerExecutor(Procedure procedure)
        {
            this.procedure = procedure;
        }

        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1031")]
        internal void ExecuteFormEventHandler()
        {
            try
            {
                Cursor.Current = Cursors.WaitCursor;

                procedure();
            }
            catch (SoapException ex)
            {
                Trace.TraceError(ex.ToString());

                MessageBox.Show(new ErrorMessageGetter(ex).GetErrorMessage(), Application.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
            }
            catch (Exception ex)
            {
                Trace.TraceError(ex.ToString());

                MessageBox.Show(ex.Message, Application.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
            }
        }
    }
}
