﻿using System;
using System.Data;

namespace TailIsland.RX
{
    internal sealed class IdentitySetter
    {
        private DataRow dataRow;
        private DataColumn dataColumn;
        private object identity;

        internal IdentitySetter(DataRow dataRow, DataColumn dataColumn, object identity)
        {
            this.dataRow = dataRow;
            this.dataColumn = dataColumn;
            this.identity = identity;
        }

        internal void SetIdentity()
        {
            foreach (DataRelation dre in dataRow.Table.ChildRelations)
            {
                if (dre.ParentColumns[0] != dataColumn)
                {
                    continue;
                }

                foreach (DataRow dro in dataRow.GetChildRows(dre))
                {
                    new IdentitySetter(dro, dre.ChildColumns[0], identity).SetIdentity();
                }
            }

            dataRow[dataColumn] = identity;
        }
    }
}
