﻿using System;
using System.Data;
using System.Web.Services.Protocols;

namespace TailIsland.RX
{
    public static class RXForWebForm
    {
        public static void ExecuteEventHandler(Procedure procedure)
        {
            if (procedure == null)
            {
                throw new ArgumentNullException("procedure");
            }

            new WebFormEventHandlerExecutor(procedure).ExecuteWebFormEventHandler();
        }

        public static long GetNewIdentity(string tableName)
        {
            if (tableName == null)
            {
                throw new ArgumentNullException("tableName");
            }

            return new NewIdentityGenerator(tableName).GenerateNewIdentity();
        }

        public static void ClearDataSetErrors(DataSet dataSet)
        {
            if (dataSet == null)
            {
                throw new ArgumentNullException("dataSet");
            }

            new DataSetErrorsClearer(dataSet).ClearErrors();
        }

        public static string CollectDataSetErrors(DataSet dataSet)
        {
            if (dataSet == null)
            {
                throw new ArgumentNullException("dataSet");
            }

            return new DataSetErrorsCollector(dataSet).CollectDataSetErrors();
        }

        public static void InitializeServiceAgent(SoapHttpClientProtocol soapHttpClientProtocol)
        {
            if (soapHttpClientProtocol == null)
            {
                throw new ArgumentNullException("soapHttpClientProtocol");
            }

            new ServiceAgentInitializer(soapHttpClientProtocol).InitializeServiceAgent();
        }
    }
}
