﻿using System;
using System.Data;

namespace TailIsland.RX
{
    internal sealed class RowErrorAdder
    {
        private DataRow dataRow;
        private string errorMessage;
        private Function<bool> hasError;

        internal RowErrorAdder(DataRow dataRow, string errorMessage, Function<bool> hasError)
        {
            this.dataRow = dataRow;
            this.errorMessage = errorMessage;
            this.hasError = hasError;
        }

        internal void AddRowError()
        {
            if (hasError != null && !hasError())
            {
                return;
            }

            dataRow.RowError = StringUtility.AppendStringAndNewLine(dataRow.RowError, errorMessage);
        }
    }
}
