﻿using System;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
using System.Web.SessionState;

namespace TailIsland.RX
{
    internal sealed class SessionLengthCalculator
    {
        private HttpSessionState httpSessionState;

        internal SessionLengthCalculator(HttpSessionState httpSessionState)
        {
            this.httpSessionState = httpSessionState;
        }

        internal long CalculateSessionLength()
        {
            long l = 0;

            if (httpSessionState != null)
            {
                foreach (string k in httpSessionState.Keys)
                {
                    l += CalculateKeyLength(k);

                    if (httpSessionState[k] != null)
                    {
                        l += CalculateValueLength(httpSessionState[k]);
                    }
                }
            }

            return l;
        }

        private static long CalculateKeyLength(string key)
        {
            return System.Text.Encoding.UTF8.GetBytes(key).Length;
        }

        private static long CalculateValueLength(object value)
        {
            using (Stream s = new MemoryStream())
            {
                new BinaryFormatter().Serialize(s, value);

                return s.Length;
            }
        }
    }
}
