﻿using System;
using System.Web;
using System.Web.Services.Protocols;
using System.Xml;

namespace TailIsland.RX
{
    internal sealed class SoapExceptionCreator
    {
        private string message;

        internal SoapExceptionCreator(string message)
        {
            this.message = message;
        }

        internal SoapException CreateSoapException()
        {
            return new SoapException(message, SoapException.ServerFaultCode, HttpContext.Current.Request.Url.ToString(), CreateSoapExceptionDetail(message));
        }

        private static XmlNode CreateSoapExceptionDetail(string message)
        {
            XmlDocument d = new XmlDocument();
            XmlNode n = d.CreateElement("detail");

            n.AppendChild(
                d.CreateElement("message")).AppendChild(
                    d.CreateTextNode(message));

            return n;
        }
    }
}
