﻿using System;
using System.Text;

namespace TailIsland.RX
{
    internal static class StringUtility
    {
        internal static string AppendStringAndNewLine(string targetString, string appendString)
        {
            if (string.IsNullOrEmpty(appendString))
            {
                throw new ArgumentException(Properties.Resources.NullOrEmptyStringCannotAdd, "appendString");
            }

            return string.Format("{0}{1}{2}", string.IsNullOrEmpty(targetString) ? string.Empty : targetString, string.IsNullOrEmpty(targetString) ? string.Empty : Environment.NewLine, appendString);
        }

        internal static string CreateCsvLine(object[] data)
        {
            if (data == null)
            {
                return string.Empty;
            }

            StringBuilder sb = new StringBuilder();

            foreach (object o in data)
            {
                sb.AppendFormat("{0}{1}", o != null ? o.ToString() : string.Empty, sb.Length > 0 ? ", " : string.Empty);
            }

            return sb.ToString();
        }
    }
}
