﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Text;

namespace TailIsland.RX
{
    internal sealed class UpdateTableAdaptersCaller
    {
        private DataTable dataTable;

        internal UpdateTableAdaptersCaller(DataTable dataTable)
        {
            this.dataTable = dataTable;
        }

        internal int CallUpdateTableAdapters()
        {
            new IdentitiesRenumberer(dataTable).RenumberIdentities();
            new ModifiedAndDeletedRowsLocker(dataTable).LockModifiedAndDeletedRows();

            int c = 0;

            c += CallUpdateTableAdaptersForAddedAndModifiedRows();
            c += CallUpdateTableAdaptersForDeletedRows();

            return c;
        }

        private int CallUpdateTableAdaptersForAddedAndModifiedRows()
        {
            int c = 0;

            using (DataSet ds = dataTable.DataSet.GetChanges(DataRowState.Added | DataRowState.Modified))
            {
                if (ds == null)
                {
                    return 0;
                }

                foreach (DataTable dt in new RelatedDataTablesGetter(ds.Tables[dataTable.TableName], null, RelatedDataTablesGetter.Condition.Child, RelatedDataTablesGetter.SortDirection.ParentIsFirst).GetRelatedDataTables())
                {
                    int c2 = CallUpdateTableAdapter(dt);

                    if (dt.TableName == dataTable.TableName)
                    {
                        c += c2;
                    }
                }

                dataTable.DataSet.Merge(ds);
            }

            return c;
        }

        private int CallUpdateTableAdaptersForDeletedRows()
        {
            int c = 0;

            using (DataSet ds = dataTable.DataSet.GetChanges(DataRowState.Deleted))
            {
                if (ds == null)
                {
                    return 0;
                }

                foreach (DataTable dt in new RelatedDataTablesGetter(ds.Tables[dataTable.TableName], null, RelatedDataTablesGetter.Condition.Child, RelatedDataTablesGetter.SortDirection.ChildIsFirst).GetRelatedDataTables())
                {
                    int c2 = CallUpdateTableAdapter(dt);

                    if (dt.TableName == dataTable.TableName)
                    {
                        c += c2;
                    }
                }

                dataTable.DataSet.Merge(ds);
            }

            return c;
        }

        private static int CallUpdateTableAdapter(DataTable dataTable)
        {
            return new TableAdapterCaller(dataTable, "Update", new object[] { }).CallTableAdapter();
        }
    }
}
