﻿using System;
using System.Diagnostics;
using TailIsland.RX.Properties;

namespace TailIsland.RX
{
    internal sealed class WebServiceExecutor
    {
        private Procedure procedure;

        internal WebServiceExecutor(Procedure procedure)
        {
            this.procedure = procedure;
        }

        internal void ExecuteWebService()
        {
            try
            {
                procedure();
            }
            catch (Exception ex)
            {
                Trace.TraceError(ex.ToString());

                throw new SoapExceptionCreator(new ErrorMessageGetter(ex).GetErrorMessage()).CreateSoapException();
            }
        }
    }
}
